'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deny = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _immutable = require('immutable');

var _utils = require('../utils');

var _grant = require('./grant');

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var shouldBeDenied = function shouldBeDenied(grant) {
  return (0, _utils.all)((0, _grant.grantHaveMembers)(grant.members), (0, _grant.grantHaveResources)(grant.resources), (0, _grant.grantHaveAttributes)(grant.attributes));
};

var splitByFilter = function splitByFilter(set) {
  return function (filter) {
    return [set.filter(filter), set.filterNot(filter)];
  };
};

var createLeftoverGrant = function createLeftoverGrant(prop) {
  return function (denyGrant) {
    return function (grant) {
      return (0, _utils.composeAll)((0, _utils.applyIf)(function (leftover) {
        return _immutable.Set.of(grant.set(prop, leftover));
      }, (0, _immutable.Set)())(function (leftover) {
        return !leftover.isEmpty();
      }), function (set) {
        return set.subtract(denyGrant.get(prop));
      }, function (grant) {
        return grant.get(prop);
      })(grant);
    };
  };
};

var createDenyReducer = (0, _utils.compose)(function (leftoverCreators) {
  return function (grantSet, grant) {
    return grantSet.union.apply(grantSet, _toConsumableArray(leftoverCreators.map(function (createLeftover) {
      return createLeftover(grant);
    })));
  };
}, (0, _utils.applyAll)(createLeftoverGrant('members'), createLeftoverGrant('resources'), createLeftoverGrant('attributes')));

var denyAndStore = function denyAndStore(store) {
  return function (denyGrant) {
    return (0, _utils.composeAll)(store.set.bind(store, 'grants'), function (_ref) {
      var _ref2 = _slicedToArray(_ref, 2),
          changed = _ref2[0],
          unchanged = _ref2[1];

      return changed.union(unchanged);
    }, (0, _utils.applyAll)(function (_ref3) {
      var _ref4 = _slicedToArray(_ref3, 1),
          staged = _ref4[0];

      return staged.reduce(createDenyReducer(denyGrant), (0, _immutable.Set)());
    }, _utils.selectLast), splitByFilter(store.grants), shouldBeDenied)(denyGrant);
  };
};

var deny = exports.deny = function deny(stateSetter, store) {
  return (0, _utils.composeAll)(stateSetter, denyAndStore(store), _grant.Grant.lift);
};