'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getPermission = exports.getGrantsByMember = undefined;

var _immutable = require('immutable');

var _grant = require('./grant');

var _utils = require('../utils');

var getGrantsByMember = exports.getGrantsByMember = function getGrantsByMember(grants) {
  return function (members) {
    return grants.filter((0, _grant.grantHaveMembers)(members));
  };
};

var getPermission = exports.getPermission = function getPermission(grants) {
  return function (resources, attributes) {
    return grants.filter(function (grant) {
      return (0, _utils.all)((0, _grant.grantHaveResources)(resources), (0, _grant.grantHaveAttributes)(attributes))(grant);
    }).reduce(function (membersSet, grant) {
      return membersSet.union(grant.members);
    }, (0, _immutable.Set)());
  };
};