'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.many = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _immutable = require('immutable');

var _utils = require('../utils');

var _grant = require('./grant');

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

var existInAll = (0, _utils.applyIf)(function (_ref) {
  var _ref2 = _toArray(_ref),
      set = _ref2[0],
      otherSets = _ref2.slice(1);

  return otherSets.length > 0 ? set.intersect.apply(set, _toConsumableArray(otherSets)) : set;
})(function (sets) {
  return sets && Array.isArray(sets) && sets.length > 0;
});

var maybeMapVal = function maybeMapVal(predicate) {
  return function (trueFunc, falseFunc) {
    return function (value) {
      return predicate(value) ? trueFunc(value) : falseFunc();
    };
  };
};
var getMembers = function getMembers(grant) {
  return grant.members;
};

var mergeIfExists = function mergeIfExists(toMergeWith) {
  return function () {
    var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : (0, _immutable.Set)();
    return toMergeWith.union(value);
  };
};

var curriedSet = function curriedSet(map) {
  return function (key) {
    return function (value) {
      return map.set(key, value);
    };
  };
};
var curriedGet = function curriedGet(map) {
  return function (key) {
    return map.get(key);
  };
};

var getMatchingResources = function getMatchingResources(resourcesList) {
  return function (grant) {
    return resourcesList.find(function (resources) {
      return (0, _grant.grantHaveResources)(resources)(grant);
    });
  };
};

var many = exports.many = function many(grants) {
  return (0, _utils.compose)(existInAll, function (resourcesList, attributes) {
    return grants.reduce(function (resourcesToMembers, grant) {
      return (0, _utils.composeAll)((0, _utils.applyIf)(function (_ref3) {
        var _ref4 = _slicedToArray(_ref3, 2),
            key = _ref4[0],
            members = _ref4[1];

        return (0, _utils.composeAll)(curriedSet(resourcesToMembers)(key), mergeIfExists(members), curriedGet(resourcesToMembers))(key);
      })(function (_ref5) {
        var _ref6 = _slicedToArray(_ref5, 1),
            val = _ref6[0];

        return !!val;
      }), (0, _utils.applyAll)(getMatchingResources(resourcesList), maybeMapVal((0, _grant.grantHaveAttributes)(attributes))(getMembers, _immutable.Set)))(grant);
    }, (0, _immutable.Map)()).toArray();
  });
};