'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _utils = require('./utils');

var _store = require('./store');

var _transformers = require('./transformers');

var _grant = require('./grant');

var _role = require('./role');

var _resource = require('./resource');

var _member = require('./member');

var grants = {
  _store: new _store.Store(),
  setStore: function setStore(store) {
    this._store = store;
  },
  clear: function clear() {
    this._store = new _store.Store();
  },


  get grant() {
    return (0, _grant.grant)(this.setStore.bind(this), this._store);
  },
  get get() {
    return (0, _utils.compose)(_transformers.setToPermitted, (0, _grant.getPermission)(this._store.grants));
  },
  get getMany() {
    return (0, _utils.compose)(_transformers.setToPermitted, (0, _grant.many)(this._store.grants));
  },
  get deny() {
    return (0, _grant.deny)(this.setStore.bind(this), this._store);
  },
  get role() {
    return (0, _role.role)(this.setStore.bind(this), this._store);
  },
  get setRole() {
    return (0, _role.setRole)(this.setStore.bind(this), this._store);
  },
  get unsetRole() {
    return (0, _role.unsetRole)(this.setStore.bind(this), this._store);
  },
  get inRole() {
    return (0, _role.inRole)(this._store.roles);
  },
  get resource() {
    return (0, _resource.resource)(this._store.grants);
  },
  get member() {
    return (0, _member.member)(this._store);
  },

  ALL: (0, _utils.UniversalSet)()
};

exports.default = grants;