'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.inRole = undefined;

var _role = require('./role');

var _get = require('./get');

var _utils = require('../utils');

var isInRole = function isInRole(role) {
  return function (member) {
    return !_role.Role.isEmpty(role) && role.members.has(member);
  };
};

var inRole = exports.inRole = function inRole(roles) {
  return (0, _utils.compose)(isInRole, (0, _get.getRoleByName)(roles));
};