'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.role = exports.isSameRole = exports.Role = undefined;

var _immutable = require('immutable');

var _transformers = require('../transformers');

var _utils = require('../utils');

var _get = require('./get');

var _set = require('./set');

var Role = exports.Role = (0, _immutable.Record)({
  name: '',
  members: (0, _immutable.Set)()
}, 'Role');

Role.lift = function (name, members) {
  return new Role({
    name: name,
    members: (0, _transformers.membersToSet)(members) || (0, _immutable.Set)()
  });
};

Role.isRole = function (role) {
  return role && role._name === 'Role';
};

Role.isEmpty = function (role) {
  return !role.members || role.members.isEmpty();
};

var isSameRole = exports.isSameRole = function isSameRole(role) {
  return function (member) {
    return Role.isRole(member) && member.name === role.name;
  };
};

var role = exports.role = function role(stateSetter, store) {
  return (0, _utils.composeAll)(_utils.selectLast, (0, _utils.applyAll)((0, _utils.compose)(stateSetter, (0, _set.setRoleToStore)(store)), _utils.identity), (0, _get.getOrCreateRole)(store.roles));
};