'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.unsetRole = exports.removeMemberFromRole = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _utils = require('../utils');

var _get = require('./get');

var _set = require('./set');

var removeMemberFromRole = exports.removeMemberFromRole = function removeMemberFromRole(roles) {
  return function (member, role) {
    return (0, _utils.composeAll)(function (_ref) {
      var _ref2 = _slicedToArray(_ref, 2),
          role = _ref2[0],
          members = _ref2[1];

      return role.set('members', members);
    }, (0, _utils.applyAll)(_utils.identity, function (role) {
      return role.members.delete(member);
    }), (0, _get.getRole)(roles))(role);
  };
};

var unsetRole = exports.unsetRole = function unsetRole(stateSetter, store) {
  return (0, _utils.composeAll)(_utils.selectLast, (0, _utils.applyAll)((0, _utils.compose)(stateSetter, function (_ref3) {
    var _ref4 = _slicedToArray(_ref3, 2),
        state = _ref4[0],
        role = _ref4[1];

    return (0, _set.updateRolesOnGrants)(state)(role);
  }), (0, _utils.compose)(_utils.identity, _utils.selectLast)), (0, _utils.applyAll)((0, _set.setRoleToStore)(store), _utils.identity), removeMemberFromRole(store.roles));
};