'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.grantToPermitted = exports.setToPermitted = exports.expandSet = exports.membersToSet = undefined;

var _immutable = require('immutable');

var _role = require('./role');

var membersToSet = exports.membersToSet = function membersToSet(members) {
  return members && (_immutable.Set.isSet(members) ? members : Array.isArray(members) ? (0, _immutable.Set)(members) : _immutable.Set.of(members));
};

var expandWithRole = function expandWithRole(set, role) {
  return set.union(role.members || (0, _immutable.Set)());
};

var expandSet = exports.expandSet = function expandSet(set) {
  return set.reduce(function (expanded, value) {
    return _role.Role.isRole(value) ? expandWithRole(expanded, value) : expanded.add(value);
  }, (0, _immutable.Set)());
};

var setToPermitted = exports.setToPermitted = function setToPermitted(set) {
  return function (value) {
    return expandSet(set).has(value);
  };
};
var grantToPermitted = exports.grantToPermitted = function grantToPermitted(grant) {
  return setToPermitted(grant.members);
};