'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var wrapMember = function wrapMember(handler) {
  return function (target) {
    return function (property) {
      return handler.get(target, property);
    };
  };
};

var proxy = exports.proxy = function proxy(handler) {
  return function (target) {
    if ('Proxy' in global) {
      return new Proxy(target, handler);
    }

    var trap = wrapMember(handler)(target);
    var wrapper = {};
    for (var property in target) {
      wrapper[property] = trap(property);
    }

    return wrapper;
  };
};