'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UniversalSet = undefined;

var _immutable = require('immutable');

var _proxy = require('./proxy');

var _utils = require('./utils');

var methods = {
  isSubset: function isSubset() {
    return false;
  },
  isSuperset: function isSuperset() {
    return true;
  },
  has: function has() {
    return true;
  },
  includes: function includes() {
    return true;
  },
  union: function union() {
    return this;
  },
  intersect: function intersect(other) {
    for (var _len = arguments.length, others = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      others[_key - 1] = arguments[_key];
    }

    return others.length >= 1 ? other.intersect.apply(other, others) : other;
  },
  subtract: function subtract() {
    throw new Error('Not Implemented');
  },
  toJS: function toJS() {
    return { universal: true };
  }
};

var handler = function handler(methods) {
  return {
    get: function get(target, property) {
      return methods[property] || target[property];
    }
  };
};

var createSetProxy = (0, _utils.compose)(_proxy.proxy, handler);

var UniversalSet = exports.UniversalSet = function UniversalSet() {
  var set = (0, _immutable.Set)();
  var setProxy = createSetProxy(methods);
  return setProxy(set);
};