'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var all = exports.all = function all() {
  for (var _len = arguments.length, predicates = Array(_len), _key = 0; _key < _len; _key++) {
    predicates[_key] = arguments[_key];
  }

  return function (value) {
    return predicates.reduce(function (result, predicate) {
      return result && predicate(value);
    }, true);
  };
};

var applyAll = exports.applyAll = function applyAll() {
  for (var _len2 = arguments.length, funcs = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    funcs[_key2] = arguments[_key2];
  }

  return function () {
    for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      args[_key3] = arguments[_key3];
    }

    return funcs.map(function (func) {
      return func.apply(null, args);
    });
  };
};

var compose = exports.compose = function compose(f, g) {
  return function () {
    return f(g.apply(undefined, arguments));
  };
};

var composeAll = exports.composeAll = function composeAll() {
  for (var _len4 = arguments.length, funcs = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
    funcs[_key4] = arguments[_key4];
  }

  return function () {
    for (var _len5 = arguments.length, args = Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
      args[_key5] = arguments[_key5];
    }

    var last = funcs.length - 1;
    var ret = args;
    for (var index = last; index >= 0; index--) {
      ret = [funcs[index].apply(null, ret)];
    }
    return ret[0];
  };
};

var identity = exports.identity = function identity(value) {
  return value;
};

var applyIf = exports.applyIf = function applyIf(func, defaultValue) {
  return function (predicate) {
    return function (value) {
      return predicate(value) ? func(value) : defaultValue !== undefined ? defaultValue : value;
    };
  };
};

var selectLast = exports.selectLast = function selectLast(arr) {
  return arr[arr.length - 1];
};

var echo = exports.echo = compose(selectLast, applyAll(function () {
  var _console;

  for (var _len6 = arguments.length, args = Array(_len6), _key6 = 0; _key6 < _len6; _key6++) {
    args[_key6] = arguments[_key6];
  }

  return (_console = console).log.apply(_console, ['@@Echoing:'].concat(_toConsumableArray(args)));
}, identity));